strapper/help/urls.py
# pylint:
from django.urls import path
from . import views

urlpatterns = [
    path('using_strapper', views.UsingStrapperPage.as_view(), name="help_using_strapper"),
    path('about_strap/', views.AboutStrapPage.as_view(), name="help_about_strap"),
]

strapper/strapper/urls.py
# pylint:
"""strapper URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/4.1/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include
from . import auth

urlpatterns = [
    path('admin-django/', admin.site.urls),
    path('login/', auth.LoginView.as_view(), name='login'),
    path('logout/', auth.LogoutView.as_view(), name='logout'),
    path('admin/', include('admin_users.urls'), name='admin_users'),
    path('content/', include('django_editablecontent.urls'), name='editablecontent'),
    path('fileupload/', include('django_fileupload.urls'), name='fileupload'),
    path('help/', include('help.urls'), name='help'),
    path('wizard/', include('wizard.urls'), name='wizard'),
    path('access/', include('access.urls'), name='access'),
    path('', include('normal_users.urls'), name='normal_users'),
]

# Add URL patterns for serving media files during development
if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

strapper/wizard/urls.py
# pylint:
from django.urls import path
from . import views

urlpatterns = [
    path('getting_started', views.GettingStartedView.as_view(), name="getting_started"),
    path('step/<int:step>', views.wizard_view, name="wizard_view")
]

strapper/normal_users/models.py
# pylint: disable=invalid-sequence-index,too-many-ancestors
#   invalid-sequence-index: sequence index is a Django model
#   IntegerField, which is an int
#   too-many-ancestors: inheriting from Django's model classes
#   and we have no control over ancestors or depth of inheritance

import os
from typing import Dict, List
import json
import time
import shlex
import re
from urllib.parse import quote_plus as urlencode, urlparse
import requests

from kubernetes import client, config as kube_config, stream

from django.db import models
from django.core import validators
from django.contrib.auth.models import User
from django.conf import settings

from admin_users.models import GeneralConfig, HarborConfig

class AuthTypes(models.TextChoices):
    UVIC = 'uvic', 'Uvic'
    UVIC_SOCIAL = 'uvic_social', 'Uvic + Social'

class DatabaseTypes(models.TextChoices):
    NONE = 'None', 'None'
    POSTGRESQL = 'PostgreSQL', 'PostgreSQL'
    MYSQL = 'MySQL', 'MySQL'

# An application configuration created by users
class Application(models.Model):
    identifier = models.CharField(max_length=16, primary_key=True)
    descriptive_name = models.CharField(max_length=100, null=False, blank=False)
    description = models.CharField(max_length=500, blank=True, default="")
    authentication = models.CharField(max_length=15, choices=AuthTypes.choices,
        null=True, blank=True)
    database = models.CharField(max_length=20, choices=DatabaseTypes.choices, default=DatabaseTypes.NONE, blank=True)
    port = models.IntegerField(null=True, blank=True,
        validators = [validators.MinValueValidator(0), validators.MaxValueValidator(65536)])
    is_secure = models.BooleanField(default=False)
    published_on_strap = models.BooleanField(default=False)
    replicas = models.IntegerField(null=False, blank=False, default=1)
    owner = models.ForeignKey(User, on_delete=models.CASCADE)
    last_updated = models.DateTimeField(auto_now=True)

    # Empty means all IPs are allowed. IPs are stored as a comma-separated list
    allowed_ips = models.CharField(max_length=300, null=True, blank=True)

    # Exempt from blocking in case vulnerability scan shows vulnerabilities
    # above threshold
    vuln_blocking_exempt = models.BooleanField(default=False)

    class Meta:
        db_table = 'application'
        ordering = ['-last_updated']

    def save(self, *args, **kwargs):
        """
        Ensure an app always has 2 role groups - editor and viewer
        """
        super().save(*args, **kwargs)

        # Create role groups if they don't exist
        if not self.approlegroup_set.filter(role='editor').exists():
            self.approlegroup_set.create(role='editor')
        if not self.approlegroup_set.filter(role='viewer').exists():
            self.approlegroup_set.create(role='viewer')

        # Create a quota if it doesn't exist
        if not ApplicationQuota.objects.filter(application=self).exists():
            ApplicationQuota.objects.create(application=self)

        # Create a quota request, set to None state if it doesn't exist
        if not hasattr(self, 'applicationquotarequest'):
            ApplicationQuotaRequest.objects.create(application=self)

    def delete(self, *args, **kwargs):
        """
        Delete all role groups of the app before deleting the app
        """
        for group in self.approlegroup_set.all():
            group.delete()
        super().delete(*args, **kwargs)

    def __repr__(self):
        return self.descriptive_name

    def is_deployable(self):
        """
        Determine if applition is deployable. An app is deployable if:
        - Its containers have no vulnerabilities higher than the threshold OR
          it is exempt from blocking due to vulnerabilities found
        - It has at least one container
        - It has a port, meaning it has a main container
        """
        return ((self.is_secure or self.vuln_blocking_exempt)
                and self.port and self.container_set.count() > 0)

    # Check if the app has a certain route
    def has_route(self, route):
        return self.route_set.filter(route=route).exists()

    def create_routes(self, route_list, authenticated=True):
        """
        Create routes (if not exist already) for the application
        Args:
            - route_list: list of routes (str) to create (might already exist)
            - authenticated: boolean, True if the routes are authenticated, False otherwise
        Returns: None
        """
        for route in route_list:
            if route and not self.has_route(route):
                if not route.startswith('/'):
                    route = '/' + route
                self.route_set.create(route=route, authenticated=authenticated)

    # Convert all routes (authenticated or unauthenticated) into a string
    # where routes are separated by a comma ','
    def routes_to_str(self, authenticated=True):
        return ','.join(route.route for route in list(self.route_set.filter(authenticated=authenticated)))

    # Similar to routes_to_str but only return authenticated routes
    # NOTE: Must keep this method to be used in Django templates
    def authenticated_routes_to_str(self):
        return self.routes_to_str(authenticated=True)

    # Similar to routes_to_str but only return unauthenticated routes
    # NOTE: Must keep this method to be used in Django templates
    def unauthenticated_routes_to_str(self):
        return self.routes_to_str(authenticated=False)

    # Returns a dictionary of allowed IPs separated by categories
    # Key: either a preset name or "others"
    # Value: a list of IPs
    def get_allowed_ips(self) -> Dict[str, List[str]]:
        if not self.allowed_ips:
            return {}

        allowed_ips = {}
        general_config = GeneralConfig.get_instance()
        preset_ips = general_config.get_preset_ips()
        for name in preset_ips.keys():
            if set(preset_ips[name]).issubset(self.allowed_ips.split(',')):
                allowed_ips[name] = preset_ips[name]

        # Combine all preset IPs into a list
        preset_ips_list = [ip for ips in preset_ips.values() for ip in ips]
        other_ips = [ip for ip in self.allowed_ips.split(',') if ip not in preset_ips_list]
        if len(other_ips):
            allowed_ips['others'] = other_ips
        return allowed_ips

    # Returns True if app has an advanced config set, False otherwise
    def has_advanced_config(self) -> bool:
        advanced_config = False
        if self.allowed_ips:
            advanced_config = True

        return advanced_config

    # Convert app configurations into a dictionary
    def build_configuration(self):
        tfvars = {}

        # General configurations
        tfvars['app_name'] = self.identifier
        tfvars['app_port'] = self.port if self.port else 80
        tfvars['authentication'] = self.authentication
        tfvars['authenticated_routes'] = (
            self.routes_to_str(authenticated=True).split(',')
            if len(self.route_set.filter(authenticated=True)) > 0
            else None
        )
        tfvars['unauthenticated_routes'] = (
            self.routes_to_str(authenticated=False).split(',')
            if len(self.route_set.filter(authenticated=False)) > 0
            else None
        )
        tfvars['database'] = self.database if self.database != 'None' else None
        tfvars['allowed_ips'] = self.allowed_ips.split(',') if self.allowed_ips else []
        tfvars['replicas'] = self.replicas

        # Containers
        containers = []
        for container in self.container_set.all():
            env_vars = container.get_environment_variables()
            container_dict = {
                'image': container.image,
                'tag': container.image_tag,
                'port': container.port if container.port else 80,
                'command': shlex.split(container.command) if container.command else None,
                'environment': env_vars if len(env_vars) != 0 else None,
                'shared_volume_path': "/tmp/mnt_shared_volume"
            }
            containers.append(container_dict)
        tfvars['containers'] = containers
        tfvars['image_credentials'] = (
            self.harborproject.build_image_credentials()
            if hasattr(self, 'harborproject')
            else None
        )

        # TODO: Fix this when adding Harbor
        tfvars['deploy'] = True

        return tfvars

    def detect_config_change(self):
        '''
        Check if there is any change made in the app configuration comparing to
        configurations used in the most recent deployment
        Returns: boolean
        - True: there is
        - False: there isn't
        '''
        # If there is no successful deployment for this app,
        # return True
        try:
            k8sinstance = self.k8sinstance
        except K8sInstance.DoesNotExist:
            return True

        # Check if there is any change in app container configurations
        containers_ids = []
        for k8scontainer in k8sinstance.k8scontainer_set.all():
            try:
                container = k8scontainer.container
            except Container.DoesNotExist:
                return True

            if not container or container.application != self:
                return True

            if (container.image != k8scontainer.image or container.image_tag != k8scontainer.image_tag
                or container.port != k8scontainer.port or container.command != k8scontainer.command
                or container.environment_variables != k8scontainer.environment_variables):
                return True

            containers_ids.append(container.id)

        # Check if there is any container that is not in the most recent deployment
        for container in self.container_set.all():
            if container.id not in containers_ids:
                return True

        # Check if there is any change in app configurations

strapper/wizard/models.py
# pylint:
from django.db import models
from django.contrib.auth.models import User

from normal_users.models import Application

# Create your models here.
class Wizard(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE, null=False, blank=False)
    step = models.IntegerField(default=1, blank=True)
    is_active = models.BooleanField(default=False, blank=True)
    app = models.OneToOneField(Application, on_delete=models.CASCADE, null=True, blank=True)
    last_updated = models.DateTimeField(auto_now=True)

    class Meta:
        db_table = 'wizard'
        ordering = ['-last_updated', 'user']

    def __repr__(self) -> str:
        return str(self)

    def __str__(self) -> str:
        return (f"{self.user.username} - step {str(self.step)} - "
                f"{self.app.descriptive_name if self.app else 'No app'}")

    def cal_progress(self) -> int:
        """
        Calculate the progress percentage based on step to display
        on Bootstrap progress bar
        """
        return (self.step - 1) * 20

    def clear(self) -> None:
        """
        Clear the wizard
        """
        self.step = 1
        self.is_active = False
        self.app = None
        self.save()

strapper/templates/wizard/authentication.html
{% extends "wizard/base.html" %}
{% block title %}Step 2: Authentication{% endblock %}
{% block step_content %}
  <div class="row">
    <div class="col-12">
      <h1 class="mt-5">Step 2: Authentication</h1>
      <p>Authentication for your app is handled by STRAP, so you don&apos;t have to worry about passwords, multifactor authentication, or user registration and confirmation emails. <a href="#">Learn how it works</a>.</p>
      <p>Choose from:</p>
      <ul>
        <li><strong>No authentication</strong>: your app doesn&apos;t need it</li>
        <li><strong>UVic</strong>: My UVic identity can authenticate using UVic's identity service</li>
        <li><strong>UVic + social</strong>: UVic and common public identity providers</li>
      </ul>

      <form method="post">
        {% csrf_token %}

            <!-- Authentication -->
        <div class="mb-3">
          <label class="form-label">Authentication</label>
          <select class="form-control authentication" name='authentication'>
            <option value='' {% if not wizard.app.authentication %}selected{% endif %}>None</option>
            <option value='uvic' {% if wizard.app.authentication == 'uvic' %}selected{% endif %}>UVic</option>
            <option value='uvic_social' {% if wizard.app.authentication == 'uvic_social' %}selected{% endif %}>UVic + Social</option>
          </select>
          <div class="form-text">How the app authenticates users</div>
        </div>

            <!-- Routes -->
        <p>Routes may be authenticated or unauthenticated. For example, the main landing page is often unauthenticated ('/') while the login page requires authentication and so creates an authenticated session for the rest of the site visit.</p>
        <div class="mb-3">
          <label class="form-label">Authenticated routes</label>
          <div class="alert alert-warning d-none" role="alert" data-role="authenticated-routes-alert">
            <i class="fa-solid fa-triangle-exclamation me-2"></i>
            Route exists as an unauthenticated route. Adding this route will remove it from the unauthenticated routes
          </div>
          <div class="routes-input">
            <input
              class="form-control"
              type='text'
              {% if not wizard.app.authentication %}disabled{% endif %}
              placeholder="Type in the route, then click 'Add' to add. E.g. /dashboard, then add"
              data-type="authenticated"></input>
            <div type="button" class="btn btn-primary disabled">Add route</div>
          </div>
          <div class="route-tag-container authenticated-routes">
            {% if wizard.app.authentication %}
              {% if wizard.app.route_set.all|length > 0 %}
                {% for route in wizard.app.route_set.all %}
                  {% if route.authenticated %}
                    <div class="route-tag mt-1"><span class="route-tag-path">{{route.route}}</span> <span class="route-tag-close {% if not wizard.app.authentication %}disabled{% endif %}">&#10005;</span></div>
                  {% endif %}
                {% endfor %}
              {% endif %}
            {% endif %}
          </div>
          <input name="authenticated_routes" class="route-hidden-input d-none authenticated-routes-input" type="text" {% if wizard.app %}value="{{wizard.app.authenticated_routes_to_str}}"{% endif %}>
          <div class="form-text">Routes subject to authentication. Click on the 'X' in each tag to remove it.</div>
        </div>

        <div class="mb-3">
          <label class="form-label">Unauthenticated routes</label>
          <div class="alert alert-warning d-none" role="alert" data-role="unauthenticated-routes-alert">
            <i class="fa-solid fa-triangle-exclamation me-2"></i>
            Route exists as an authenticated route. Adding this route will remove it from the authenticated routes
          </div>
          <div class="routes-input">
            <input
              class="form-control"
              type='text'
              {% if not wizard.app.authentication %}disabled{% endif %}
              placeholder="Type in the route, then click 'Add' to add. E.g. /, then add"
              data-type="unauthenticated"></input>
            <div type="button" class="btn btn-primary disabled">Add route</div>
          </div>
          <div class="route-tag-container unauthenticated-routes">
            {% if not wizard.app.authentication %}
              <div class="route-tag mt-1"><span class="route-tag-path">/</span> <span class="route-tag-close disabled">&#10005;</span></div>
            {% else %}
              {% if wizard.app.route_set.all|length > 0 %}
                {% for route in wizard.app.route_set.all %}
                  {% if not route.authenticated %}
                    <div class="route-tag mt-1"><span class="route-tag-path">{{route.route}}</span> <span class="route-tag-close">&#10005;</span></div>
                  {% endif %}
                {% endfor %}
              {% endif %}
            {% endif %}
          </div>
          <input name="unauthenticated_routes" class="route-hidden-input d-none unauthenticated-routes-input" type="text"
                 {% if wizard.app.authentication %}
                   value="{{wizard.app.unauthenticated_routes_to_str}}"
                 {% else %}
                   value="/"
                 {% endif %}
          >
          <div class="form-text">Routes exempt from authentication. Click on the 'X' in each tag to remove it.</div>
        </div>

            <!-- Navigation buttons -->
        {% with is_form=True %}
          {% include 'wizard/navigation_btns.html' %}
        {% endwith %}
      </form>
    </div>
  </div>
{% endblock %}

strapper/templates/wizard/base.html
{% extends "base.html" %}
{% block static %}
  {% load static %}
  <link rel="stylesheet" type="text/css" href="{% static 'style/app.css' %}">
  <link rel="stylesheet" type="text/css" href="{% static 'style/wizard/wizard.css' %}">
{% endblock %}
{% block content %}
  <main class="container">
    <!-- Wizard progress bar -->
    <div class="progress-container">
      <div class="progress" role="progressbar" aria-label="Basic example" aria-valuenow="{{ wizard.cal_progress }}" aria-valuemin="0" aria-valuemax="100">
        <div class="progress-bar bg-success" style="width: {{ wizard.cal_progress }}%"></div>
        <a href="{% url 'wizard_view' step=1 %}" class="hit-point {% if wizard.step >= 1 %}completed{% endif %} {% if active_step == 1 %}active{% endif %}">
          <i class="fa-solid fa-gear fs-6"></i>
        </a>
        <a href="{% url 'wizard_view' step=2 %}" class="hit-point {% if wizard.step >= 2 %}completed{% endif %} {% if active_step == 2 %}active{% endif %}" style="left: 20%">
          <i class="fa-solid fa-user-lock fs-6"></i>
        </a>
        <a href="{% url 'wizard_view' step=3 %}" class="hit-point {% if wizard.step >= 3 %}completed{% endif %} {% if active_step == 3 %}active{% endif %}" style="left: 40%">
          <i class="fa-solid fa-database fs-6"></i>
        </a>
        <a href="{% url 'wizard_view' step=4 %}" class="hit-point {% if wizard.step >= 4 %}completed{% endif %} {% if active_step == 4 %}active{% endif %}" style="left: 60%">
          <i class="fa-solid fa-building-columns fs-6"></i>
        </a>
        <a href="{% url 'wizard_view' step=5 %}" class="hit-point {% if wizard.step >= 5 %}completed{% endif %} {% if active_step == 5 %}active{% endif %}" style="left: 80%">
          <i class="fa-solid fa-cube fs-6"></i>
        </a>
        <a href="{% url 'wizard_view' step=6 %}" class="hit-point {% if wizard.step >= 6 %}completed{% endif %} {% if active_step == 6 %}active{% endif %}" style="left: 100%">
          <i class="fa-solid fa-rocket fs-6"></i>
        </a>
      </div>
    </div>
    <div class="progress-container mt-4">
      <span class="hit-point-title {% if active_step == 1 %}fw-bold{% endif %}" data-step="1">Basics</span>
      <span class="hit-point-title {% if active_step == 2 %}fw-bold{% endif %}" data-step="2">Authentication</span>
      <span class="hit-point-title {% if active_step == 3 %}fw-bold{% endif %}" data-step="3">Database</span>
      <span class="hit-point-title {% if active_step == 4 %}fw-bold{% endif %}" data-step="4">Image registry</span>
      <span class="hit-point-title {% if active_step == 5 %}fw-bold{% endif %}" data-step="5">Containers</span>
      <span class="hit-point-title {% if active_step == 6 %}fw-bold{% endif %}" data-step="6">Review</span>
    </div>

    <section class="mt-lg-5">
      {% block step_content %}
      {% endblock %}
    </section>
  </main>
{% endblock %}
{% block script %}
  <script src="{% static 'js/wizard/wizard.js' %}" type="module"></script>
{% endblock %}

strapper/templates/wizard/basics.html
{% extends "wizard/base.html" %}
{% block title %}Step 1: Create an app{% endblock %}
{% block step_content %}
  <div class="row">
    <div class="col-12">
      <h1 class="mt-5">Step 1: Basics</h1>
      <p class="lead">Fill out some basic information about your app</p>
      <form method="post">
        {% csrf_token %}

            <!-- Identifier -->
        <div class="mb-3">
          <div class="d-flex flex-row gap-5">
            <label class="form-label fw-semibold">Identifier (Required)</label>
            <div class="form-label"><strong>App URL: </strong><span id="app-domain-id">{% if wizard.app %}{{ wizard.app.identifier }}{% endif %}</span>.{{ general_config.domain }}</div>
          </div>
          <div class="text-danger mb-1 d-none">Identifier already exists</div>
          <input name="identifier" type="text" class="form-control app-identifier-input" data-existing-identifiers="{{existing_identifiers}}" {% if wizard.app.identifier %}value="{{wizard.app.identifier}}" disabled {% endif %} placeholder="e.g. myapp" minlength='3' maxlength='16' pattern='[a-z][a-z0-9]*' required>
          <p class="form-text">Must be short (3-16 characters) and unique. This cannot be changed later and it will show up in the app's URL. <br>For example, if your identifier is <strong>myapp</strong>, your app's URL will be <strong>myapp.{{ strap_domain }}</strong></p>
        </div>

            <!-- Descriptive name -->
        <div class="mb-3">
          <label class="form-label fw-semibold">Descriptive name (Required)</label>
          <input name="descriptive_name" type="text" class="form-control descriptive-name" {% if wizard.app.descriptive_name %}value="{{wizard.app.descriptive_name}}"{% endif %} placeholder='e.g. My Application' required>
          <div class="form-text">A longer and human-readable name for your app that can be updated. This is used for presentation in Strapper and for the listing on the STRAP page (if you choose to do so).</div>
        </div>

            <!-- Description -->
        <div class="mb-3">
          <label class="form-label fw-semibold">Description</label>
          <textarea name="description" class="form-control" placeholder='e.g. My Application serves my research data products to a managed list of users' rows="3" {% if wizard.app.published_on_strap %}required{% endif %}>{% if wizard.app.description %}{{wizard.app.description}}{% endif %}</textarea>
          <div class="form-text">Used on the public listing on the STRAP page (if you choose to do so)</div>
        </div>

            <!-- Display on STRAP page -->
        <div class="form-check">
          <input
            class="form-check-input"
            type="checkbox"
            name="published_on_strap"
            id="flexCheckDefault"
            {% if wizard.app.published_on_strap %}checked{% endif %}>
          <label class="form-check-label" for="flexCheckDefault">
            Okay to publish name and description on STRAP page
          </label>
        </div>

            <!-- Navigation buttons -->
        {% with is_form=True %}
          {% include 'wizard/navigation_btns.html' %}
        {% endwith %}
      </form>
    </div>
  </div>
{% endblock %}

strapper/templates/wizard/getting_started.html
{% extends "base.html" %}
{% block static %}
  {% load static %}
  <link rel="stylesheet" type="text/css" href="{% static 'style/app.css' %}">
  <link rel="stylesheet" type="text/css" href="{% static 'style/wizard/wizard.css' %}">
{% endblock %}
{% block content %}
  <main class="container">
    <section class="mt-lg-5">
      <div class="row">
        <div class="col-12">
          <h1 class="mt-5">Getting started</h1>
          <p class="mt-3">Welcome to the STRAP wizard! We&apos;ll guide you in setting up your app on the platform, one step at a time and explain core concepts and components along the way.</p>
          <p>Hover over <a >key terms</a> to get a brief explanation. Where appropriate we&apos;ve provided links to more <a href="#">in-depth documentation.</a></p>
          <p>More experienced users may choose to skip the wizard and use the <a href="{% url 'dashboard' %}">Expert mode</a></p>
          <p>Still with us? Then let&apos;s get started!</p>

                <!-- Navigation buttons -->
          {% with is_form=False %}
            {% include 'wizard/navigation_btns.html' %}
          {% endwith %}
        </div>
      </div>
    </section>
  </main>
{% endblock %}

strapper/templates/wizard/review.html
{% extends "wizard/base.html" %}
{% block title %}Step 6: Review{% endblock %}
{% block step_content %}
  <div class="row">
    <div class="col-12">
      <h1 class="mt-5">Step 6: Review</h1>
      <p><strong>Congratulations!</strong> You have created the necessary configurations for your app to run properly. Let&apos;s review the steps we've been through.</p>
      <h4>Basic configurations</h4>
      <ul class="review-checklist">
        <li><i class="fa-solid fa-check text-success"></i>Id: <strong>{{ wizard.app.identifier }}</strong></li>
        <li><i class="fa-solid fa-check text-success"></i>Name: <strong>{{ wizard.app.descriptive_name }}</strong></li>
        {% if wizard.app.description %}
          <li><i class="fa-solid fa-check text-success"></i>Description: <strong>{{ wizard.app.description }}</strong></li>
        {% elif wizard.app.published_on_strap %}
          <li><i class="fa-solid fa-xmark text-danger"></i>Description: None</li>
        {% else %}
          <li><i class="fa-solid fa-xmark"></i>Description: None</li>
        {% endif %}
        <li><i class="fa-solid fa-check text-success"></i>Published on STRAP page: <strong>{% if wizard.app.published_on_strap %}Yes{% else %}No{% endif %}</strong></li>
      </ul>

      <h4>Authentication</h4>
      <ul class="review-checklist">
        {% if wizard.app.authentication %}
          <li><i class="fa-solid fa-check text-success"></i>Authentication type: <strong>{{ wizard.app.get_authentication_display }}</strong></li>
          {% if wizard.app.unauthenticated_routes_to_str %}
            <li><i class="fa-solid fa-check text-success"></i>Unauthenticated routes: <strong>{{ wizard.app.unauthenticated_routes_to_str }}</strong></li>
          {% else %}
            <li><i class="fa-solid fa-xmark"></i>Unauthenticated routes: None</li>
          {% endif %}
          {% if wizard.app.authenticated_routes_to_str %}
            <li><i class="fa-solid fa-check text-success"></i>Authenticated routes: <strong>{{ wizard.app.authenticated_routes_to_str }}</strong></li>
          {% else %}
            <li><i class="fa-solid fa-xmark"></i>Authenticated routes: None</li>
          {% endif %}
        {% else %}
          <li><i class="fa-solid fa-xmark"></i>No authentication was set up</li>
        {% endif %}
      </ul>

      <h4>Database</h4>
      <ul class="review-checklist">
        {% if wizard.app.database != 'None' %}
          <li><i class="fa-solid fa-check text-success"></i>Database type: <strong>{{ wizard.app.get_database_display }}</strong></li>
        {% else %}
          <li><i class="fa-solid fa-xmark"></i>No database was set up</li>
        {% endif %}
      </ul>

      <h4>Image registry</h4>
      <ul class="review-checklist">
        {% if wizard.app.harborproject %}
          <li><i class="fa-solid fa-check text-success"></i>Name: <strong>{{ wizard.app.harborproject.project_name }}</strong></li>
          <li><i class="fa-solid fa-check text-success"></i>Username: <strong>{{ wizard.app.harborproject.username }}</strong></li>
          <li class="row"><i class="fa-solid fa-check text-success mt-1"></i>Password:
            <span class="password-display w-fit">
              <div class="password">****************</div>
              <pre class="text d-none"><code>{{ wizard.app.harborproject.password }}</code></pre>
              <div class="show-btn">Show</div>
            </span>
          </li>
        {% else %}
          <li><i class="fa-solid fa-xmark text-danger"></i>No image registry was set up</li>
        {% endif %}
      </ul>

      <h4>Container</h4>
      <ul class="review-checklist">
        {% if wizard.app.container_set.count > 0 %}
          {% for container in wizard.app.container_set.all %}
            <li><i class="fa-solid fa-check text-success"></i><strong>{{ container }}</strong></li>
          {% endfor %}
        {% else %}
          <li><i class="fa-solid fa-xmark text-danger"></i>No container was set up</li>
        {% endif %}
      </ul>

      <a href="{% url 'get_app' identifier=wizard.app.identifier %}">Go to your application configuration now!</a>

      <h1 class="mt-5">Next step</h1>
      <p>Let&apos;s start deploying our app by finishing the following remaining steps:</p>
      <ul>
        <li>Make sure your containers are secure.</li>
        <li>Click the <strong>Review</strong> button in the app page to start deploying.</li>
        <li>Wait for the deployment to finish and you can visit your app at <strong>{{ wizard.app.identifier }}.{{ general_config.domain }}</strong>.</li>
      </ul>

        <!-- Navigation buttons -->
      {% with is_form=False %}
        {% include 'wizard/navigation_btns.html' %}
      {% endwith %}
    </div>
  </div>
{% endblock %}